/////////////////////////////////////////
//  OtBbNteXgvO   //
//  2016/3/2  SG12864  timer.c         //
//  PIC18F452  MPLAB v8.92  C18 v3.47  //
/////////////////////////////////////////
#include "global.h"

///// ^C}[ݒlƊJn̒l̔z
static  uint set_time[TIMER_NUM];
static  uint start_time[TIMER_NUM];
//////////////////
volatile uint tics;                     //^C}[pJEgl

///// ^C}[
void timer_init(void){
    int n;

    T1CON = 0x81;                       //Timer1 16bit,ps1/1,enable
    TMR1H = 0;                          //Timer1 clear
    TMR1L = 0;
    PIE1bits.TMR1IE = 0;                //Timer1 荞݋֎~
    CCP1CON = 0xb;                      //Special Event
    CCPR1H = 0x13;
    CCPR1L = 0x88;
    IPR1bits.CCP1IP = 1;                //荞ݗD惌xʑɂĂ
    PIE1bits.CCP1IE = 1;                //bbo荞݋
    for(n = 0; n < TIMER_NUM; n++) set_time[n] = 0;
}

///// ^C}[Jn
//    F^C}[ԍA^C}[l
void timer_start(int num, uint time){
    if(set_time[num]) return;
    set_time[num] = time;
    start_time[num] = tics;
}

///// ^C}[ăX^[g
//    F^C}[ԍA^C}[l
void timer_restart(int num, uint time){
    set_time[num] = time;
    start_time[num] = tics;
}

///// ^C}[LZ
//    F^C}[ԍ
void timer_cancel(int num){
    set_time[num] = 0;
}

///// ^CAbṽ`FbN
//    F^C}[ԍ
int timer_check(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    set_time[num] = 0;
    return 1;
}

///// ^CAbvăX^[g
//    F^C}[ԍ
int timer_check_start(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    start_time[num] = tics;
    return 1;
}
